## API Report File for "@primitivefi/rmm-ethers"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { AllocateOptions } from '@primitivefi/rmm-sdk';
import { BatchTransferOptions } from '@primitivefi/rmm-sdk';
import { BigNumber } from 'ethers';
import { BigNumber as BigNumber_2 } from '@ethersproject/bignumber';
import { BlockTag } from '@ethersproject/abstract-provider';
import { Contract } from '@ethersproject/contracts';
import { ContractInterface } from '@ethersproject/contracts';
import { Log } from '@ethersproject/abstract-provider';
import { LogDescription } from '@ethersproject/abi';
import { Pool } from '@primitivefi/rmm-sdk';
import { PoolSides } from '@primitivefi/rmm-sdk';
import { PopulatedTransaction } from '@ethersproject/contracts';
import { PositionDescriptor } from '@primitivefi/rmm-manager/typechain/PositionDescriptor';
import { PositionRenderer } from '@primitivefi/rmm-manager/typechain/PositionRenderer';
import { PrimitiveFactory } from '@primitivefi/rmm-core/typechain/PrimitiveFactory';
import { PrimitiveManager } from '@primitivefi/rmm-manager/typechain/PrimitiveManager';
import { Provider } from '@ethersproject/abstract-provider';
import { RemoveOptions } from '@primitivefi/rmm-sdk';
import { SafeTransferOptions } from '@primitivefi/rmm-sdk';
import { Signer } from '@ethersproject/abstract-signer';
import { Signer as Signer_2 } from 'ethers';
import { SwapOptions } from '@primitivefi/rmm-sdk';
import { TransactionReceipt } from '@ethersproject/abstract-provider';
import { TransactionRequest } from '@ethersproject/abstract-provider';
import { TransactionResponse } from '@ethersproject/abstract-provider';
import { Wei } from 'web3-units';

// @internal (undocumented)
export const _connect: (signerOrProvider: EthersSigner | EthersProvider) => Promise<EthersRmmConnection>;

// Warning: (ae-incompatible-release-tags) The symbol "connectionFrom" is marked as @public, but its signature references "_RmmContracts" which is marked as @internal
// Warning: (ae-incompatible-release-tags) The symbol "connectionFrom" is marked as @public, but its signature references "_RmmDeploymentJSON" which is marked as @internal
// Warning: (ae-incompatible-release-tags) The symbol "connectionFrom" is marked as @public, but its signature references "_InternalEthersRmmConnection" which is marked as @internal
//
// @public
export const connectionFrom: (provider: EthersProvider, signer: EthersSigner | undefined, _contracts: _RmmContracts, { deploymentDate, ...deployment }: _RmmDeploymentJSON) => _InternalEthersRmmConnection;

// @internal (undocumented)
export const _connectToContracts: (signerOrProvider: EthersSigner | EthersProvider, { addresses }: _RmmDeploymentJSON) => _RmmContracts;

// @internal (undocumented)
export const _connectToDeployment: (deployment: _RmmDeploymentJSON, signerOrProvider: EthersSigner | EthersProvider) => EthersRmmConnection;

// Warning: (ae-incompatible-release-tags) The symbol "_connectToNetwork" is marked as @public, but its signature references "EthersRmmConnection" which is marked as @beta
//
// @public (undocumented)
export function _connectToNetwork(provider: EthersProvider, signer: EthersSigner | undefined, chainId: number): EthersRmmConnection;

// @public
export type EngineAddress = string;

// @public
export interface EngineCreationDetails {
    engine: EngineAddress;
    params: EngineCreationParams;
}

// @public
export type EngineCreationParams = {
    risky: string;
    stable: string;
};

// @public
export interface EthersCallOverrides {
    // (undocumented)
    blockTag?: BlockTag;
}

// @public
export type EthersPopulatedTransaction = PopulatedTransaction;

// @public
export type EthersProvider = Provider;

// @beta
export class EthersRmm implements ReadableEthersRmm {
    // @internal
    constructor(readable: ReadableEthersRmm);
    allocate(params: PositionAllocateParams, overrides?: EthersTransactionOverrides): Promise<PositionAdjustmentDetails>;
    static connect(signerOrProvider: Signer_2 | Provider): Promise<EthersRmm>;
    readonly connection: EthersRmmConnection;
    createEngine(params: EngineCreationParams, overrides?: EthersTransactionOverrides): Promise<EngineCreationDetails>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: No member was found with name "createPool"
    //
    // (undocumented)
    createPool(params: PositionAllocateParams, overrides?: EthersTransactionOverrides): Promise<PositionAdjustmentDetails>;
    // (undocumented)
    static _from(connection: EthersRmmConnection): EthersRmm;
    getEngine(riskyAddress: string, stableAddress: string, overrides?: EthersCallOverrides): Promise<EngineAddress>;
    getLiquidityBalance(poolId: string, address: string, overrides?: EthersCallOverrides): Promise<Wei>;
    getPool(poolId: string, overrides?: EthersCallOverrides): Promise<Pool>;
    getPosition(pool: Pool, address: string, overrides?: EthersCallOverrides): Promise<Position>;
    readonly populate: PopulatableEthersRmm;
    remove(params: PositionRemoveParams, overrides?: EthersTransactionOverrides): Promise<PositionAdjustmentDetails>;
    safeBatchTransfer(params: PositionBatchTransferParams, overrides?: EthersTransactionOverrides): Promise<void>;
    safeTransfer(params: PositionTransferParams, overrides?: EthersTransactionOverrides): Promise<void>;
    readonly send: SendableEthersRmm;
}

// @beta
export interface EthersRmmConnection {
    readonly addresses: Record<string, string>;
    readonly chainId: number;
    readonly deploymentDate: Date;
    readonly provider: EthersProvider;
    readonly signer: EthersSigner;
    readonly startBlock: number;
}

// @public (undocumented)
export interface EthersRmmConnectionOptional {
    // Warning: (ae-forgotten-export) The symbol "EthersRmmStoreOption" needs to be exported by the entry point index.d.ts
    //
    // @beta
    readonly hasStore?: EthersRmmStoreOption;
}

// @public
export type EthersSigner = Signer;

// @public
export class EthersTransactionFailedError extends TransactionFailedError<FailedReceipt<EthersTransactionReceipt>> {
    constructor(message: string, failedReceipt: FailedReceipt<EthersTransactionReceipt>);
}

// @public
export interface EthersTransactionOverrides {
    // (undocumented)
    from?: string;
    // (undocumented)
    gasLimit?: BigNumber_2;
    // (undocumented)
    gasPrice?: BigNumber_2;
    // (undocumented)
    nonce?: number;
}

// @public
export type EthersTransactionReceipt = TransactionReceipt;

// @public
export type EthersTransactionRequest = TransactionRequest;

// @public
export type EthersTransactionResponse = TransactionResponse;

// @public
export type FailedReceipt<R = unknown> = {
    status: 'failed';
    rawReceipt: R;
};

// @internal (undocumented)
export const _failedReceipt: <R>(rawReceipt: R) => FailedReceipt<R>;

// @internal (undocumented)
export const _getContracts: (connection: EthersRmmConnection) => _RmmContracts;

// @internal (undocumented)
export interface _InternalEthersRmmConnection extends EthersRmmConnection {
    // (undocumented)
    readonly addresses: _RmmContractAddresses;
    // (undocumented)
    readonly _contracts: _RmmContracts;
    // (undocumented)
    readonly _multicall?: any;
}

// @public
export type MinedReceipt<R = unknown, D = unknown> = FailedReceipt<R> | SuccessfulReceipt<R, D>;

// @public
export function parseTokenURI(uri: string): any;

// @public
export type PendingReceipt = {
    status: 'pending';
};

// @internal (undocumented)
export const _pendingReceipt: PendingReceipt;

// @internal (undocumented)
export type _PoolAction = {
    pool: Pool;
};

// @beta
export function poolify(raw: string): Pool;

// @beta
export class PopulatableEthersRmm implements PopulatableRmm<EthersTransactionReceipt, EthersTransactionResponse, EthersTransactionRequest> {
    constructor(readable: ReadableEthersRmm);
    allocate(params: PositionAllocateParams, overrides?: EthersTransactionOverrides): Promise<PopulatedEthersSignerTransaction<PositionAdjustmentDetails>>;
    createEngine(params: EngineCreationParams, overrides?: EthersTransactionOverrides): Promise<PopulatedEthersSignerTransaction<EngineCreationDetails>>;
    remove(params: PositionRemoveParams, overrides?: EthersTransactionOverrides): Promise<PopulatedEthersSignerTransaction<PositionAdjustmentDetails>>;
    safeBatchTransfer(params: PositionBatchTransferParams, overrides?: EthersTransactionOverrides): Promise<PopulatedEthersSignerTransaction<void>>;
    safeTransfer(params: PositionTransferParams, overrides?: EthersTransactionOverrides): Promise<PopulatedEthersSignerTransaction<void>>;
}

// @beta
export interface PopulatableRmm<R = unknown, S = unknown, P = unknown> {
    allocate(params: PositionAllocateParams): Promise<PopulatedRmmTransaction<P, SentRmmTransaction<S, RmmReceipt<R, PositionAdjustmentDetails>>>>;
    createEngine(params: EngineCreationParams): Promise<PopulatedRmmTransaction<P, SentRmmTransaction<S, RmmReceipt<R, EngineCreationDetails>>>>;
    // (undocumented)
    remove(params: PositionRemoveParams): Promise<PopulatedRmmTransaction<P, SentRmmTransaction<S, RmmReceipt<R, PositionAdjustmentDetails>>>>;
    safeBatchTransfer(params: PositionBatchTransferParams): Promise<PopulatedRmmTransaction<P, SentRmmTransaction<S, RmmReceipt<R, void>>>>;
    safeTransfer(params: PositionTransferParams): Promise<PopulatedRmmTransaction<P, SentRmmTransaction<S, RmmReceipt<R, void>>>>;
}

// @beta
export class PopulatedEthersSignerTransaction<T = unknown> implements PopulatedRmmTransaction<EthersTransactionRequest, SentEthersRmmTransaction<T>> {
    // @internal
    constructor(rawPopulatedTransaction: EthersTransactionRequest, connection: EthersRmmConnection, parse: (rawReceipt: EthersTransactionReceipt) => T);
    // (undocumented)
    readonly rawPopulatedTransaction: EthersTransactionRequest;
    // (undocumented)
    send(): Promise<SentEthersRmmTransaction<T>>;
}

// @public
export interface PopulatedRmmTransaction<P = unknown, T extends SentRmmTransaction = SentRmmTransaction> {
    readonly rawPopulatedTransaction: P;
    // @beta
    send(): Promise<T>;
}

// @beta
export class Position {
    // @internal
    constructor(pool: Pool, liquidity?: Wei);
    add(that: Position): Position;
    get balance0(): Wei;
    get balance1(): Wei;
    equals(that: Position): boolean;
    get isEmpty(): boolean;
    readonly liquidity: Wei;
    readonly pool: Pool;
    sub(that: Position): Position;
    get totalValue(): Wei;
    get value(): {
        valuePerLiquidity: Wei;
        values: Wei[];
    };
    valueOf(side: PoolSides): Wei;
}

// @public
export interface PositionAdjustmentDetails {
    createdPool?: boolean;
    // Warning: (ae-incompatible-release-tags) The symbol "newPosition" is marked as @public, but its signature references "Position" which is marked as @beta
    newPosition: Position;
    params: PositionAllocateParams | PositionRemoveParams;
}

// Warning: (ae-incompatible-release-tags) The symbol "PositionAllocateParams" is marked as @public, but its signature references "_PoolAction" which is marked as @internal
//
// @public
export type PositionAllocateParams<T = unknown> = _PoolAction & {
    options: AllocateOptions;
};

// @public
export type PositionBatchTransferParams = {
    options: BatchTransferOptions;
};

// @internal (undocumented)
export interface _PositionChange<T> {
    // (undocumented)
    newPosition: Position;
    // (undocumented)
    params: T;
}

// Warning: (ae-incompatible-release-tags) The symbol "PositionRemoveParams" is marked as @public, but its signature references "_PoolAction" which is marked as @internal
//
// @public
export type PositionRemoveParams = _PoolAction & {
    options: RemoveOptions;
};

// @public
export type PositionTransferParams = {
    options: SafeTransferOptions;
};

// @internal (undocumented)
export enum _RawErrorReason {
    // (undocumented)
    TRANSACTION_CANCELLED = "cancelled",
    // (undocumented)
    TRANSACTION_FAILED = "transaction failed",
    // (undocumented)
    TRANSACTION_REPLACED = "replaced",
    // (undocumented)
    TRANSACTION_REPRICED = "repriced"
}

// @beta
export class ReadableEthersRmm implements ReadableRmm {
    // @internal
    constructor(connection: EthersRmmConnection);
    static connect(signerOrProvider: EthersSigner | EthersProvider): Promise<ReadableEthersRmm>;
    // (undocumented)
    readonly connection: EthersRmmConnection;
    // @internal (undocumented)
    static _from(connection: EthersRmmConnection): ReadableEthersRmm;
    getEngine(riskyAddress: string, stableAddress: string, overrides?: EthersCallOverrides): Promise<EngineAddress>;
    getLiquidityBalance(poolId: string, address: string, overrides?: EthersCallOverrides): Promise<Wei>;
    getPool(poolId: string, overrides?: EthersCallOverrides): Promise<Pool>;
    getPosition(pool: Pool, address: string, overrides?: EthersCallOverrides): Promise<Position>;
}

// @beta
export interface ReadableRmm {
    readonly connection: EthersRmmConnection;
    getEngine(riskyAddress: string, stableAddress: string, overrides?: EthersCallOverrides): Promise<EngineAddress>;
    getLiquidityBalance(poolId: string, address: string, overrides?: EthersCallOverrides): Promise<Wei>;
    getPool(poolId: string, overrides?: EthersCallOverrides): Promise<Pool>;
    getPosition(pool: Pool, address: string, overrides?: EthersCallOverrides): Promise<Position>;
}

// @public (undocumented)
export class _RmmContract {
    constructor(addressOrName: string, contractInterface: ContractInterface, signerOrProvider?: EthersSigner | EthersProvider);
    // (undocumented)
    readonly contract: Contract;
    // (undocumented)
    extractEvents(logs: Log[], name: string): _TypedLogDescription<unknown>[];
}

// @internal (undocumented)
export const _RmmContractAbis: {
    primitiveFactory: any[];
    primitiveManager: any[];
    positionRenderer: any[];
    positionDescriptor: any[];
    primitiveEngine: any;
};

// Warning: (ae-forgotten-export) The symbol "RmmContractsKey" needs to be exported by the entry point index.d.ts
//
// @internal (undocumented)
export type _RmmContractAddresses = Record<RmmContractsKey, string>;

// @internal (undocumented)
export interface _RmmContracts {
    // Warning: (ae-forgotten-export) The symbol "PositionDescriptorContract" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    positionDescriptor: PositionDescriptorContract;
    // Warning: (ae-forgotten-export) The symbol "PositionRendererContract" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    positionRenderer: PositionRendererContract;
    // Warning: (ae-forgotten-export) The symbol "FactoryContract" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    primitiveFactory: FactoryContract;
    // Warning: (ae-forgotten-export) The symbol "ManagerContract" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    primitiveManager: ManagerContract;
}

// @internal (undocumented)
export interface _RmmDeploymentJSON {
    // (undocumented)
    readonly addresses: _RmmContractAddresses;
    // (undocumented)
    readonly chainId: number;
    // (undocumented)
    readonly deploymentDate: number;
    // (undocumented)
    readonly _isDev: boolean;
    // (undocumented)
    readonly startBlock: number;
    // (undocumented)
    readonly version: string;
}

// @public
export type RmmReceipt<R = unknown, D = unknown> = PendingReceipt | MinedReceipt<R, D>;

// @alpha
export abstract class RmmStore<T = unknown> {
    // @internal (undocumented)
    protected abstract _doStart(): () => void;
    // (undocumented)
    protected _load(): void;
    // (undocumented)
    protected _loaded: boolean;
    // (undocumented)
    logging: boolean;
    // (undocumented)
    onLoaded?: () => void;
    // @internal (undocumented)
    protected abstract _reduceExtra(extraState: T, extraStateUpdate: Partial<T>): T;
    start(): () => void;
    // @beta
    get state(): RmmStoreState<T>;
    subscribe(listener: (params: RmmStoreListenerParams<T>) => void): () => void;
    // Warning: (ae-forgotten-export) The symbol "RmmBaseStoreState" needs to be exported by the entry point index.d.ts
    //
    // (undocumented)
    protected _update(baseStateUpdate?: Partial<RmmBaseStoreState>, extraStateUpdate?: Partial<T>): void;
}

// @public
export interface RmmStoreListenerParams<T = unknown> {
    newState: RmmStoreState<T>;
    oldState: RmmStoreState<T>;
    stateChange: Partial<RmmStoreState<T>>;
}

// Warning: (ae-forgotten-export) The symbol "RmmDerivedStoreState" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export type RmmStoreState<T = unknown> = RmmBaseStoreState & RmmDerivedStoreState & T;

// @beta
export class SendableEthersRmm implements SendableRmm<EthersTransactionReceipt, EthersTransactionResponse> {
    constructor(populate: PopulatableEthersRmm);
    allocate(params: PositionAllocateParams, overrides?: EthersTransactionOverrides): Promise<SentEthersRmmTransaction<PositionAdjustmentDetails>>;
    createEngine(params: EngineCreationParams, overrides?: EthersTransactionOverrides): Promise<SentEthersRmmTransaction<EngineCreationDetails>>;
    remove(params: PositionRemoveParams, overrides?: EthersTransactionOverrides): Promise<SentEthersRmmTransaction<PositionAdjustmentDetails>>;
    safeBatchTransfer(params: PositionBatchTransferParams, overrides?: EthersTransactionOverrides): Promise<SentEthersRmmTransaction<void>>;
    safeTransfer(params: PositionTransferParams, overrides?: EthersTransactionOverrides): Promise<SentEthersRmmTransaction<void>>;
}

// @public (undocumented)
export interface SendableRmm<R = unknown, S = unknown> {
}

// @beta
export class SentEthersRmmTransaction<T = unknown> implements SentRmmTransaction<EthersTransactionResponse, RmmReceipt<EthersTransactionReceipt, T>> {
    // @internal
    constructor(rawSentTransaction: EthersTransactionResponse, connection: EthersRmmConnection, parse: (rawReceipt: EthersTransactionReceipt) => T);
    // (undocumented)
    getReceipt(): Promise<RmmReceipt<EthersTransactionReceipt, T>>;
    // (undocumented)
    readonly rawSentTransaction: EthersTransactionResponse;
    // (undocumented)
    waitForReceipt(): Promise<MinedReceipt<EthersTransactionReceipt, T>>;
}

// @public (undocumented)
export interface SentRmmTransaction<S = unknown, T extends RmmReceipt = RmmReceipt> {
    getReceipt(): Promise<T>;
    readonly rawSentTransaction: S;
    waitForReceipt(): Promise<Extract<T, MinedReceipt>>;
}

// @public
export type SuccessfulReceipt<R = unknown, D = unknown> = {
    status: 'succeeded';
    rawReceipt: R;
    details: D;
};

// @internal (undocumented)
export const _successfulReceipt: <R, D>(rawReceipt: R, details: D, toString?: (() => string) | undefined) => SuccessfulReceipt<R, D>;

// Warning: (ae-incompatible-release-tags) The symbol "SwapParams" is marked as @public, but its signature references "_PoolAction" which is marked as @internal
//
// @public
export type SwapParams = _PoolAction & {
    options: SwapOptions;
};

// @public
export class TransactionFailedError<T extends FailedReceipt = FailedReceipt> extends Error {
    // @internal
    constructor(name: string, message: string, failedReceipt: T);
    // (undocumented)
    readonly failedReceipt: T;
}

// @public (undocumented)
export interface _TypedLogDescription<T> extends Omit<LogDescription, 'args'> {
    // (undocumented)
    args: T;
}

// Warning: (ae-forgotten-export) The symbol "TypedContract" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export type _TypedRmmContract<T = unknown, U = unknown> = TypedContract<_RmmContract, T, U>;

// Warning: (ae-forgotten-export) The symbol "BucketOfFunctions" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export type _TypeSafeContract<T> = Pick<T, {
    [P in keyof T]: BucketOfFunctions extends T[P] ? never : P;
} extends {
    [_ in keyof T]: infer U;
} ? U : never>;

// (No @packageDocumentation comment for this package)

```
